package org.jvnet.annox.model;

import org.jvnet.annox.model.XAnnotationField.XAnnotation;
import org.jvnet.annox.model.XAnnotationField.XAnnotationArray;
import org.jvnet.annox.model.XAnnotationField.XBoolean;
import org.jvnet.annox.model.XAnnotationField.XBooleanArray;
import org.jvnet.annox.model.XAnnotationField.XByte;
import org.jvnet.annox.model.XAnnotationField.XByteArray;
import org.jvnet.annox.model.XAnnotationField.XChar;
import org.jvnet.annox.model.XAnnotationField.XCharArray;
import org.jvnet.annox.model.XAnnotationField.XClass;
import org.jvnet.annox.model.XAnnotationField.XClassArray;
import org.jvnet.annox.model.XAnnotationField.XDouble;
import org.jvnet.annox.model.XAnnotationField.XDoubleArray;
import org.jvnet.annox.model.XAnnotationField.XEnum;
import org.jvnet.annox.model.XAnnotationField.XEnumArray;
import org.jvnet.annox.model.XAnnotationField.XFloat;
import org.jvnet.annox.model.XAnnotationField.XFloatArray;
import org.jvnet.annox.model.XAnnotationField.XInt;
import org.jvnet.annox.model.XAnnotationField.XIntArray;
import org.jvnet.annox.model.XAnnotationField.XLong;
import org.jvnet.annox.model.XAnnotationField.XLongArray;
import org.jvnet.annox.model.XAnnotationField.XShort;
import org.jvnet.annox.model.XAnnotationField.XShortArray;
import org.jvnet.annox.model.XAnnotationField.XString;
import org.jvnet.annox.model.XAnnotationField.XStringArray;

public interface XAnnotationVisitor<T> {

	public T visitAnnotation(org.jvnet.annox.model.XAnnotation annotation);

	public T visitBooleanField(XBoolean field);

	public T visitByteField(XByte field);

	public T visitIntField(XInt field);

	public T visitLongField(XLong field);

	public T visitShortField(XShort field);

	public T visitCharField(XChar field);

	public T visitClassField(XClass field);

	public T visitDoubleField(XDouble field);

	public T visitFloatField(XFloat field);

	public T visitEnumField(XEnum field);

	public T visitStringField(XString field);

	public T visitAnnotationField(XAnnotation field);

	public T visitBooleanArrayField(XBooleanArray field);

	public T visitByteArrayField(XByteArray field);

	public T visitIntArrayField(XIntArray field);

	public T visitLongArrayField(XLongArray field);

	public T visitShortArrayField(XShortArray field);

	public T visitCharArrayField(XCharArray field);

	public T visitClassArrayField(XClassArray field);

	public T visitDoubleArrayField(XDoubleArray field);

	public T visitFloatArrayField(XFloatArray field);

	public T visitEnumArrayField(XEnumArray field);

	public T visitStringArrayField(XStringArray field);

	public T visitAnnotationArrayField(XAnnotationArray field);

}
