package org.jvnet.annox.model;

import java.lang.reflect.AnnotatedElement;
import java.lang.reflect.Member;

import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;

public abstract class XMember<T extends Member & AnnotatedElement> extends
		XAnnotatedElement<T> {

	public T getMember() {
		return getAnnotatedElement();
	}

	public String getName() {
		return getMember().getName();
	}

	public XMember(final T member, final XAnnotation[] xannotations) {
		super(member, xannotations);
	}

	@Override
	public int hashCode() {
		return new HashCodeBuilder().append(getMember()).append(
				getXAnnotations()).toHashCode();
	}

	@Override
	public boolean equals(Object obj) {
		if (obj == null)
			return false;
		if (!getClass().isAssignableFrom(obj.getClass())) {
			return false;
		}
		if (this == obj) {
			return true;
		}
		XMember rhs = (XMember) obj;
		return new EqualsBuilder().append(getMember(), rhs.getMember()).append(
				getXAnnotations(), rhs.getXAnnotations()).isEquals();
	}

}
